/** @file ute-print-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UTE_PRINT_CLO_H
#define UTE_PRINT_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef PRINT_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define PRINT_PARSER_PACKAGE "ute print"
#endif

#ifndef PRINT_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define PRINT_PARSER_PACKAGE_NAME "ute print"
#endif

#ifndef PRINT_PARSER_VERSION
/** @brief the program version */
#define PRINT_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct print_args_info
{
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  const char *do_not_throw_errors_upon_unknown_options_help; /**< @brief  help description.  */
  char * format_arg;	/**< @brief Use the specified parser, see below for a list..  */
  char * format_orig;	/**< @brief Use the specified parser, see below for a list. original value given at command line.  */
  const char *format_help; /**< @brief Use the specified parser, see below for a list. help description.  */
  char * output_arg;	/**< @brief Write result to specified output file, or stdout if omitted..  */
  char * output_orig;	/**< @brief Write result to specified output file, or stdout if omitted. original value given at command line.  */
  const char *output_help; /**< @brief Write result to specified output file, or stdout if omitted. help description.  */
  
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int do_not_throw_errors_upon_unknown_options_given ;	/**< @brief Whether do-not-throw-errors-upon-unknown-options was given.  */
  unsigned int format_given ;	/**< @brief Whether format was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct print_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure print_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure print_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *print_args_info_purpose;
/** @brief the usage string of the program */
extern const char *print_args_info_usage;
/** @brief the description string of the program */
extern const char *print_args_info_description;
/** @brief all the lines making the help output */
extern const char *print_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *print_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int print_parser (int argc, char **argv,
  struct print_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use print_parser_ext() instead
 */
int print_parser2 (int argc, char **argv,
  struct print_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int print_parser_ext (int argc, char **argv,
  struct print_args_info *args_info,
  struct print_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int print_parser_dump(FILE *outfile,
  struct print_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int print_parser_file_save(const char *filename,
  struct print_args_info *args_info);

/**
 * Print the help
 */
void print_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void print_parser_print_full_help(void);
/**
 * Print the version
 */
void print_parser_print_version(void);

/**
 * Initializes all the fields a print_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void print_parser_params_init(struct print_parser_params *params);

/**
 * Allocates dynamically a print_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized print_parser_params structure
 */
struct print_parser_params *print_parser_params_create(void);

/**
 * Initializes the passed print_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void print_parser_init (struct print_args_info *args_info);
/**
 * Deallocates the string fields of the print_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void print_parser_free (struct print_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int print_parser_required (struct print_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UTE_PRINT_CLO_H */
